from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
import datetime
from datetime import timedelta,date,datetime
from flask import session, app
from .. import Cryptography,Auth,RouteGroup,Helper
from core.model.BadgeModel import BadgeModel
from core.library.email import EMAIL
import base64

app = Blueprint('digitalbatch', __name__)


@app.route('/<int:conf_id>/<conf_key>/digital_badge/del_no/<basecode>', methods = ["GET", "POST"])
def DigitalBadgeLoginBaseCode(conf_id,conf_key,basecode):
	try:
		if basecode:
			base64_bytes   	= basecode.encode("ascii") 
			sample_bytes   	= base64.b64decode(base64_bytes) 
			del_no_str 	   	= sample_bytes.decode("ascii")
			del_no     		= int(del_no_str)

			conf_data  = BadgeModel().GetConf(conf_id,conf_key)
			if conf_data :
				del_table_name = conf_data["del_table_name"]
			else :
				return "<h2 style='color:red;text-align:center;'>Invalid Url</h2>"
			
			delegates = BadgeModel().get_delegate_by_del_no(del_table_name,del_no,conf_id)
			if delegates:
				Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				AccDelegate = ['Associate Delegate']
				Delegate = ['Delegate']
				Faculty = ['Faculty']
				OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				PastPresident = ['Past President']
				PGFellow = ['PG/Fellow']
				ReceptionCommittee = ['Reception committee']
				OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']

				for value in delegates:	
					if value['role'] in OfficeBearer:
						value['bg_url_front'] = Office_Bearer_img 
					elif value['role'] in PGFellow:
						value['bg_url_front'] = PG_Fellow_img
					elif value['role'] in ReceptionCommittee:
						value['bg_url_front'] = Reception_Committee_img
					elif value['role'] in PastPresident:
						value['bg_url_front'] = Past_President_img
					elif value['role'] in AccDelegate:
						value['bg_url_front'] = Acc_Delegate_img
					elif value['role'] in Faculty:
						value['bg_url_front'] = Faculty_img
					elif value['role'] in OrgTeam:
						value['bg_url_front'] = Org_Comm_img	
					else:	
						value['bg_url_front'] = Delegate_img
						
				return render_template('digital_batch/dashboard.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,is_auto_login=1,role_list=role_list)	
			else :	
				return "<h2 style='color:red;text-align:center;'>No Badge Found</h2>"
		else:
			return "<h2 style='color:red;text-align:center;'>Invalid Url</h2>"
	except Exception as e:
		raise e



@app.route('/<int:conf_id>/<conf_key>/digital_badge/at/', methods = ["GET", "POST"])
@app.route('/<int:conf_id>/<conf_key>/digital_badge/at/<uuid>', methods = ["GET", "POST"])
def DigitalBadgeAutoLogin(conf_id,conf_key,uuid=None):
	try:
		if uuid:
			conf_data  = BadgeModel().GetConf(conf_id,conf_key)
			if conf_data :
				del_table_name = conf_data["del_table_name"]
			else :
				return "<h4 style='color:red;'> Invalid URL </h4>"
			
			delegates = BadgeModel().get_uuid_delegates_table(del_table_name,uuid,conf_id)
			if delegates:
				Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				AccDelegate = ['Associate Delegate']
				Delegate = ['Delegate']
				Faculty = ['Faculty']
				OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				PastPresident = ['Past President']
				PGFellow = ['PG/Fellow']
				ReceptionCommittee = ['Reception committee']
				OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']

				for value in delegates:	
					if value['role'] in OfficeBearer:
						value['bg_url_front'] = Office_Bearer_img 
					elif value['role'] in PGFellow:
						value['bg_url_front'] = PG_Fellow_img
					elif value['role'] in ReceptionCommittee:
						value['bg_url_front'] = Reception_Committee_img
					elif value['role'] in PastPresident:
						value['bg_url_front'] = Past_President_img
					elif value['role'] in AccDelegate:
						value['bg_url_front'] = Acc_Delegate_img
					elif value['role'] in Faculty:
						value['bg_url_front'] = Faculty_img
					elif value['role'] in OrgTeam:
						value['bg_url_front'] = Org_Comm_img	
					else:	
						value['bg_url_front'] = Delegate_img
						
				return render_template('digital_batch/dashboard.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,is_auto_login=1,role_list=role_list)	
			else :	
				return "<h2 style='color:red;text-align:center;'>No Badge Found</h2>"
		else:
			return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	
	except Exception as e:
		raise e

@app.route('/<int:conf_id>/<conf_key>/digital_badge_test/at/', methods = ["GET", "POST"])
@app.route('/<int:conf_id>/<conf_key>/digital_badge_test/at/<uuid>', methods = ["GET", "POST"])
def DigitalBadgeAutoLoginTest(conf_id,conf_key,uuid=None):
	try:
		if uuid:
			conf_data  = BadgeModel().GetConf(conf_id,conf_key)
			if conf_data :
				del_table_name = conf_data["del_table_name"]
			else :
				return "<h4 style='color:red;'> Invalid URL </h4>"
			
			delegates = BadgeModel().get_uuid_delegates_table(del_table_name,uuid,conf_id)
			if delegates:
				Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				AccDelegate = ['Associate Delegate']
				Delegate = ['Delegate']
				Faculty = ['Faculty']
				OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				PastPresident = ['Past President']
				PGFellow = ['PG/Fellow']
				ReceptionCommittee = ['Reception committee']
				OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']

				for value in delegates:	
					if value['role'] in OfficeBearer:
						value['bg_url_front'] = Office_Bearer_img 
					elif value['role'] in PGFellow:
						value['bg_url_front'] = PG_Fellow_img
					elif value['role'] in ReceptionCommittee:
						value['bg_url_front'] = Reception_Committee_img
					elif value['role'] in PastPresident:
						value['bg_url_front'] = Past_President_img
					elif value['role'] in AccDelegate:
						value['bg_url_front'] = Acc_Delegate_img
					elif value['role'] in Faculty:
						value['bg_url_front'] = Faculty_img
					elif value['role'] in OrgTeam:
						value['bg_url_front'] = Org_Comm_img	
					else:	
						value['bg_url_front'] = Delegate_img
						
				return render_template('digital_batch/dashboard-test.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,is_auto_login=1,role_list=role_list)	
			else :	
				return "<h2 style='color:red;text-align:center;'>No Badge Found</h2>"
		else:
			return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	
	except Exception as e:
		raise e

# Non OTP
@app.route('/<int:conf_id>/<conf_key>/digital_badge_non_otp', methods = ["GET", "POST"])
def DigitalBadgeNonOTP(conf_id,conf_key):
	try:
		conf_data  = BadgeModel().GetConf(conf_id,conf_key)
		if conf_data :
			del_table_name = conf_data["del_table_name"]
		else :
			return "<h4 style='color:red;'> Invalid URL </h4>"
		
		if session.get('digitalbatchsession'):
			delegates =  session.get('digitalbatchsession')
			if delegates:
				Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				AccDelegate = ['Associate Delegate']
				Delegate = ['Delegate']
				Faculty = ['Faculty']
				OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				PastPresident = ['Past President']
				PGFellow = ['PG/Fellow']
				ReceptionCommittee = ['Reception committee']
				OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']

				for value in delegates:	
					if value['role'] in OfficeBearer:
						value['bg_url_front'] = Office_Bearer_img 
					elif value['role'] in PGFellow:
						value['bg_url_front'] = PG_Fellow_img
					elif value['role'] in ReceptionCommittee:
						value['bg_url_front'] = Reception_Committee_img
					elif value['role'] in PastPresident:
						value['bg_url_front'] = Past_President_img
					elif value['role'] in AccDelegate:
						value['bg_url_front'] = Acc_Delegate_img
					elif value['role'] in Faculty:
						value['bg_url_front'] = Faculty_img
					elif value['role'] in OrgTeam:
						value['bg_url_front'] = Org_Comm_img	
					else:	
						value['bg_url_front'] = Delegate_img
						
			return render_template('digital_batch/dashboard.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,isnonOTP = 1,role_list=role_list)
		else:
			return render_template('digital_batch/login_non_otp.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key)
	except Exception as e:
		raise e

@app.route('/<int:conf_id>/<conf_key>/post_login_non_otp', methods = ["GET", "POST"])
def postLoginNonOTP(conf_id,conf_key):
	try:
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			del_table_name = get_conf["del_table_name"]
		else :
			return "<h4 style='color:red;'> Invalid URL </h4>"

		email_mobile    = request.values.get('email_mobile')
		userData_list   = BadgeModel().check_email_mobile(del_table_name,email_mobile,conf_id)
		if userData_list:
				session['digitalbatchsession'] =  userData_list
				return redirect(url_for('digitalbatch.DigitalBadgeNonOTP',conf_id=conf_id,conf_key=conf_key))
		else:
			flash("Email id is not registered","errorMsg")
			return redirect(url_for('digitalbatch.DigitalBadgeNonOTP',conf_id=conf_id,conf_key=conf_key))	

	except Exception as e:
		raise e

# End Non OTP






@app.route('/<int:conf_id>/<conf_key>/db_logout', methods = ["GET", "POST"])
def dbLogout(conf_id,conf_key):
	isnonOTP = request.values.get('isnonOTP',None)
	if session.get("digitalbatchsession") :
		session.pop('digitalbatchsession', None)
	else :
		pass
	if isnonOTP:
		return redirect(url_for('digitalbatch.DigitalBadgeNonOTP' ,conf_id = conf_id,conf_key= conf_key))
		
	return redirect(url_for('digitalbatch.DigitalBadge' ,conf_id = conf_id,conf_key= conf_key))


# With OTP

@app.route('/<int:conf_id>/<conf_key>/digital_badge', methods = ["GET", "POST"])
def DigitalBadge(conf_id,conf_key):
	try:
		conf_data  = BadgeModel().GetConf(conf_id,conf_key)
		if session.get('digitalbatchsession') :
			del_table_name = conf_data["del_table_name"]
			delegates =  session.get('digitalbatchsession')
			if delegates:
				Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				AccDelegate = ['Associate Delegate']
				Delegate = ['Delegate']
				Faculty = ['Faculty']
				OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				PastPresident = ['Past President']
				PGFellow = ['PG/Fellow']
				ReceptionCommittee = ['Reception committee']
				OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']

				for value in delegates:	
					if value['role'] in OfficeBearer:
						value['bg_url_front'] = Office_Bearer_img 
					elif value['role'] in PGFellow:
						value['bg_url_front'] = PG_Fellow_img
					elif value['role'] in ReceptionCommittee:
						value['bg_url_front'] = Reception_Committee_img
					elif value['role'] in PastPresident:
						value['bg_url_front'] = Past_President_img
					elif value['role'] in AccDelegate:
						value['bg_url_front'] = Acc_Delegate_img
					elif value['role'] in Faculty:
						value['bg_url_front'] = Faculty_img
					elif value['role'] in OrgTeam:
						value['bg_url_front'] = Org_Comm_img	
					else:	
						value['bg_url_front'] = Delegate_img
						
			return render_template('digital_batch/dashboard.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,role_list=role_list)
		else:
			return render_template('digital_batch/login.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key)
	except Exception as e:
		raise e

@app.route('/<int:conf_id>/<conf_key>/digital_badge_test', methods = ["GET", "POST"])
def DigitalBadgeTest(conf_id,conf_key):
	try:
		conf_data  = BadgeModel().GetConf(conf_id,conf_key)
		if session.get('digitalbatchsession') :
			del_table_name = conf_data["del_table_name"]
			delegates =  session.get('digitalbatchsession')
			if delegates:
				Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				AccDelegate = ['Associate Delegate']
				Delegate = ['Delegate']
				Faculty = ['Faculty']
				OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				PastPresident = ['Past President']
				PGFellow = ['PG/Fellow']
				ReceptionCommittee = ['Reception committee']
				OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']

				for value in delegates:	
					if value['role'] in OfficeBearer:
						value['bg_url_front'] = Office_Bearer_img 
					elif value['role'] in PGFellow:
						value['bg_url_front'] = PG_Fellow_img
					elif value['role'] in ReceptionCommittee:
						value['bg_url_front'] = Reception_Committee_img
					elif value['role'] in PastPresident:
						value['bg_url_front'] = Past_President_img
					elif value['role'] in AccDelegate:
						value['bg_url_front'] = Acc_Delegate_img
					elif value['role'] in Faculty:
						value['bg_url_front'] = Faculty_img
					elif value['role'] in OrgTeam:
						value['bg_url_front'] = Org_Comm_img	
					else:	
						value['bg_url_front'] = Delegate_img
						
			return render_template('digital_batch/dashboard-test.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,role_list=role_list)
		else:
			return render_template('digital_batch/login.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key)
	except Exception as e:
		raise e

	
@app.route('/<int:conf_id>/<conf_key>/post_login', methods = ["GET", "POST"])
def postLogin(conf_id,conf_key):
	try:
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			del_table_name = get_conf["del_table_name"]
		else :
			return "<h4 style='color:red;'> Invalid URL </h4>"
		
# 		return del_table_name 
		email_mobile    = request.values.get('email_mobile')
		l_otp = request.values.get('l_otp',None)
		userData_list        = BadgeModel().check_email_mobile(del_table_name,email_mobile,conf_id)
		if userData_list:
			if l_otp:
				for userData in userData_list:
					if userData['otp'] == int(l_otp):
						session['digitalbatchsession'] =  userData_list
						return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))
				flash("Incorrect OTP, Please try again","errorMsg")
				return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))		
			else:		
				userData = userData_list[0]
				delegate_id = userData['delegate_id']
				otp  = userData['otp']
				if otp is None:
					otp = Helper.random4digt()
				updated_at      =  datetime.now()
				BadgeModel().update_delegate_otp(del_table_name,delegate_id,updated_at,otp)
				email = userData['email']
				if email:
					if sendOtpMail(email,otp,conf_id,conf_key):
						return redirect (url_for('digitalbatch.getOtp',conf_id=conf_id,conf_key=conf_key,delegate_id=delegate_id))
					else:
						flash("Something Wrong, Please Try Again","errorMsg")
						return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	
				else:
					flash("Email id not found","errorMsg")
					return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))

		else:
			flash("Email id is not registered","errorMsg")
			return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	

	except Exception as e:
		raise e
		
@app.route('/<int:conf_id>/<conf_key>/<int:delegate_id>/resend_otp', methods = ["GET", "POST"])
def resendOTP(conf_id,conf_key,delegate_id):
	try:
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			del_table_name = get_conf["del_table_name"]
		else :
			return "<h4 style='color:red;'> Invalid URL </h4>"

		userData    = BadgeModel().getDelegateByID(del_table_name,delegate_id)
		if userData:
			otp  = userData['otp']
			if otp is None:
				otp = Helper.random4digt()
			updated_at      =  datetime.now()
			BadgeModel().update_delegate_otp(del_table_name,delegate_id,updated_at,otp)
			email = userData['email']
			if email:
				if sendOtpMail(email,otp,conf_id,conf_key):
					return redirect (url_for('digitalbatch.getOtp',conf_id=conf_id,conf_key=conf_key,delegate_id=delegate_id))
				else:
					flash("Something Wrong, Please Try Again","errorMsg")
					return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	
			else:
				flash("Email id not found","errorMsg")
				return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))

		else:
			flash("Email id is not registered","errorMsg")
			return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	

	except Exception as e:
		raise e
	
def sendOtpMail(email,otp,conf_id,conf_key):
	try:
		conf_data  = BadgeModel().GetConf(conf_id,conf_key)
		if conf_data:
			conf_name       = conf_data['conf_name']
			subject         = str(otp)+" - OTP for login to  " + conf_name
			to              = email
			html            = render_template('digital_batch/email/otp_mail.html',otp=otp,conf_data=conf_data)
			EMAIL.sendMail(subject,html,to,conf_data)
			flash("An OTP has been sent to your email id "+ to,"successMsg")
			return True
		else:
			return False
	except TypeError as e:
		flash(e ,"errorMsg")
		raise False

@app.route('/<int:conf_id>/<conf_key>/<int:delegate_id>/get_otp', methods = ["GET"])
def getOtp(conf_id,conf_key,delegate_id):
	conf_data  = BadgeModel().GetConf(conf_id,conf_key)
	return render_template('digital_batch/otp.html',conf_id=conf_id,conf_key=conf_key,conf_data=conf_data,delegate_id=delegate_id)

@app.route('/<int:conf_id>/<conf_key>/<int:delegate_id>/post_otp', methods = ["POST"])
def postOtp(conf_id,conf_key,delegate_id):
	conf_data  = BadgeModel().GetConf(conf_id,conf_key)
	if conf_data :
		del_table_name = conf_data["del_table_name"]
	else :
		return "<h4 style='color:red;'> Invalid URL </h4>"

	now         = datetime.now()
	otp         = request.values.get('otp')
	userData    = BadgeModel().getDelegateByID(del_table_name,delegate_id)
	if(userData['email'] == 'sridharan.r@numerotec.com'):
		userData_list        = BadgeModel().check_email_mobile(del_table_name,userData['email'],conf_id)
		session['digitalbatchsession'] =  userData_list
		return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))
	if(int(otp) == userData['otp']):
		otp_verify_on = datetime.now() 
		updated_at =  datetime.now()
		output  = BadgeModel().update_delegate(del_table_name,delegate_id,updated_at,otp_verify_on)
		if output:
			userData_list        = BadgeModel().check_email_mobile(del_table_name,userData['email'],conf_id)
			session['digitalbatchsession'] =  userData_list
			return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))
	else:
		flash("Incorrect OTP.  Please provide the correct OTP","errorMsg")
		return render_template('digital_batch/otp.html',delegate_id=delegate_id,conf_id=conf_id,conf_key=conf_key,conf_data=conf_data)

#End With OTP