from flask import request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
from core.model.BadgeModel import BadgeModel
from core.model.RegdeskModel import RegdeskModel
from .. import  Custom


from .. import Cryptography
from flask import  app
from random import randint
import datetime
from datetime import timedelta,date,datetime,time
from werkzeug.utils import secure_filename
from os.path import join, dirname, realpath
import os
from collections import OrderedDict
from collections import defaultdict
from json import dumps

app = Blueprint('regdesk', __name__)



@app.route('/delegate_auto_present_generate', methods = ["GET", "POST"])
def DelegateAutoPresentGenerate():
	generate_present = RegdeskModel().generateDelegatePresent()
	return "success"

# http://127.0.0.1:5001/regdesk_login?api_key=w347H52d96&conf_key=selsi22&regdesk_pin=1234
#http://127.0.0.1:5003/regdesk_login?api_key=w347H52d96&regdesk_pin=2023
@app.route('/regdesk_login', methods = ["GET", "POST"])
def RegdeskLogin():
	json_data     = []
	confData      = []
	delegate_data = []
	msg           = ""
	signed_count  = 0
	now           = datetime.now()
	curr_dt       = now.strftime("%Y-%m-%d %H:%M:%S")
	try:
		APIKEY      = request.values.get("api_key",None)
		regdesk_pin = request.values.get('regdesk_pin') or None
		if APIKEY  and  APIKEY == Custom.APIKEY :
			confData    = RegdeskModel().getConfDataForRegdesk(regdesk_pin)
			if confData : 
				conf_start_time = confData["conf_start_time"]
				conf_end_time   = confData["conf_end_time"]
				del_table_name  = confData["del_table_name"]
				conf_id         = confData["conf_id"]
				conf_key        = confData["conf_key"]
				conf_start_time_str = conf_start_time.strftime("%Y-%m-%d %H:%M:%S")
				conf_end_time_str = conf_end_time.strftime("%Y-%m-%d %H:%M:%S")

				if conf_start_time < now < conf_end_time :
					# condition true
					delegateData = RegdeskModel().delegateData(conf_id,del_table_name)
					if delegateData :
						delegate_data = delegateData
						key_order = ["delegate_id","delegate_no","role","full_name","email","mobile","city","state","membership_no","mc_number","counter","batch","signed_by","comments","signed_on","updated_at","conf_id"]
						
						 
						# for index,value in enumerate(delegate_data) : 
						# 	signed_on = value["signed_on"]
						# 	if signed_on :
						# 		signed_count = signed_count + 1
							
						data = {'conf_data' : confData ,'delegate_data' : delegate_data ,'signed_count': signed_count ,'msg' : "success", 'status' : 1}
						
						result = defaultdict(list)
						for dic in data["delegate_data"]:
							signed_on = dic["signed_on"]
							if signed_on :
								signed_count = signed_count + 1

							ordered = OrderedDict((key, dic.get(key)) for key in key_order)
							result["delegate_data"].append(ordered)

						data["signed_count"] = signed_count
						json_data = dumps(data ,default=str)
						return json_data

				elif conf_start_time > now :
					status   = 4
					msg      = "Conference not yet start. It will start on " + conf_start_time_str
					
				elif now > conf_end_time :
					status   = 5
					msg      = "Conference is completed on "+  conf_end_time_str
				else :
					status = "Try again"
					status = 6

				data = {'conf_data' : confData ,'delegate_data' : delegate_data ,'signed_count': signed_count ,'msg' : msg, 'status' : status}
			else :
				data = {'conf_data' : [] ,'delegate_data' : delegate_data ,'signed_count': signed_count,'msg' : 'Invalid pin or Regdesk may be closed.', 'status' : 3}
		else :
			data = {'conf_data' : [] ,'delegate_data' : delegate_data,'signed_count': signed_count, 'msg' : 'Invalid API KEY', 'status' : 2}

		json_data = json.dumps(data,default= str)
		return json_data			
	
	except Exception as e:
		data = {'conf_data' : [],'delegate_data' : delegate_data ,'signed_count': signed_count, 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data,default= str)
		return json_data		
	
	except Exception as e:
		data = {'conf_data' : [],'delegate_data' : delegate_data ,'signed_count': signed_count, 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data,default= str)
		return json_data
		
# http://127.0.0.1:5001/delegate_data_to_android?api_key=w347H52d96&conf_key=selsi22&regdesk_pin=1234
@app.route('/delegate_data_to_android', methods = ["GET", "POST"])
def DelegateDataToAndroid():
	json_data = {}
	now         = datetime.now()
	curr_dt     = now.strftime("%Y-%m-%d %H:%M:%S")
	try:
		APIKEY      = request.values.get("api_key",None)
		conf_key    = request.values.get('conf_key')  or None
		regdesk_pin = request.values.get('regdesk_pin') or None
		if APIKEY  and  APIKEY == Custom.APIKEY :
			confData    = RegdeskModel().getConfDataForRegdesk(conf_key)
			if confData : 
				db_regdesk_pin = confData["regdesk_pin"]
				if regdesk_pin and int(regdesk_pin) == db_regdesk_pin :
					conf_id         = confData["conf_id"]
					conf_start_time = confData["conf_start_time"]
					conf_end_time   = confData["conf_end_time"]
					del_table_name  = confData["del_table_name"]
					is_regdesk_open = confData["is_regdesk_open"]
					if is_regdesk_open  <= 0 :
						data = {'delegate_data' : [] , 'msg' : 'Regdesk not open', 'status' : 6}
					else :
						delegate_data   = RegdeskModel().delegateData(conf_id,del_table_name)
						if delegate_data :
							data = {'delegate_data' : delegate_data , 'msg' : 'success', 'status' : 1}
						else : 	
							data = {'delegate_data' : [] , 'msg' : 'Delegate record is empty', 'status' : 2}
				else :
					data = {'delegate_data' : [] , 'msg' : 'Invalid Pin', 'status' : 3}
			else :
				data = {'delegate_data' : [] , 'msg' : 'Invalid username', 'status' : 4}
		else :
			data = {'delegate_data' : [] , 'msg' : 'Invalid API KEY', 'status' : 5}

		json_data = json.dumps(data,default= str)		
		return json_data			
	
	except Exception as e:
		data = {'delegate_data' : [] , 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data,default= str)
		return json_data

# ---------------- not complete ------- Feb 25, 2023 
# http://127.0.0.1:5001/save_singup_record?api_key=w347H52d96&conf_id=1&delegate_no=1&del_table_name=delegates_iages23&signed_by=DELEGATE
@app.route('/save_singup_record', methods = ["GET", "POST"])
def SaveSignupRecord():
	json_data    = {}
	delegate_nos = []
	signed_count = 0
	msg          = ""
	update_stmt  = "" 
	signed_on_1    = None
	signed_count_1 = None
	is_valid     = "Invalid"
	now          = datetime.now()
	curr_dt      = now.strftime("%Y-%m-%d %H:%M:%S")
	try:
		conf_id	       = request.values.get('conf_id') or None
		APIKEY         = request.values.get("api_key") or None
		del_table_name = request.values.get('del_table_name') or None
		delegate_no    = request.values.get('delegate_no') or None
			
		if delegate_no :
			delegate_no = int(delegate_no)

		signed_by	   = request.values.get('signed_by') or 'DELEGATE'	
		comments	   = request.values.get('comments') or None
		signed_on      = curr_dt
		sync_at        = curr_dt
		updated_at     = curr_dt

		if APIKEY  and  APIKEY == Custom.APIKEY :
			# if comments :
			# 	update_stmt = update_stmt + " update  " + del_table_name + " set signed_on = '"+signed_on+"' , comments = '" + comments+"' , signed_by ='" + signed_by+"',sync_at= '"+curr_dt+"'  where delegate_no = "+str(delegate_no)+ ""
			# else :
			# 	update_stmt = update_stmt + " update  " + del_table_name + " set signed_on = '"+signed_on+"' , signed_by ='" + signed_by+"',sync_at= '"+curr_dt+"'  where delegate_no = "+str(delegate_no)+ ""
	
			update_and_get_count = RegdeskModel().updateAndGetSignedCount(conf_id,delegate_no,del_table_name,curr_dt,signed_by,comments)
			if update_and_get_count :
				for index,value in enumerate(update_and_get_count) :
					if index == 0 :
						is_valid_1 = value
					if index == 1 :
						signed_on_1 = value
					if index == 2 :
						signed_count_1 = value	


				
				if signed_count_1 :
					signed_count = signed_count_1[0]["signed_count"]
				# March 01, 2023
				if is_valid_1 :
					is_valid  = is_valid_1[0]["is_valid"]
					signed_on = None
					if is_valid  != "Valid" :
						msg     = "Sorry !. " + str(delegate_no) + " is doesn't exists in badge count list"
						status  = 5
						data    = {"signed_count" : signed_count, "signed_on" : signed_on, "msg" : msg , "status" : status}
						json_data = json.dumps(data ,default=str)
						return json_data
				# end	

				if signed_on_1 :
					signed_on = signed_on_1[0]["signed_on"]
					if signed_on :
						status    = 3
						signed_on = datetime.strptime(signed_on, '%Y-%m-%d %H:%M:%S')
						signed_on = signed_on.strftime("%d-%m-%Y %H:%M:%S")
						msg       = "Already signed at " + signed_on
					else:
						status = 1
						msg    = "success"

				data = {"signed_count" : signed_count, "signed_on" : signed_on, "msg" : msg , "status" : status}
				json_data = json.dumps(data ,default=str)
				return json_data
			else :
				msg    = "Signed data does not exist"
				status = 4
				data   = {"signed_count" : signed_count, "signed_on" : "", "msg" : msg , "status" : status}
				json_data = json.dumps(data ,default=str)
				return json_data	
		else :
			data = {'signed_count' : 0 ,'signed_count' : 0, 'msg' : 'Invalid API KEY', 'status' : 2}
			json_data = json.dumps(data ,default=str)
			return json_data	
	except Exception as e:
		data = {'signed_count' : 0,'signed_count' : 0 , 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data ,default=str)
		return json_data

# ---------------

# 2023-02-26 sync all data with signed count
# syncAllDataWithSignedCount(self,conf_id,del_table_name,date_1)
# http://127.0.0.1:5003/sync_toandroid_with_count?api_key=w347H52d96&conf_id=1&del_table_name=delegates_iages23
@app.route('/sync_toandroid_with_count', methods = ["GET", "POST"])
def SyncToAndroidWithCount():
	json_data    = {}
	signed_count = 0
	msg          = ""
	key_order    = ["delegate_id","delegate_no","role","full_name","email","mobile","city","state","membership_no","mc_number","counter","batch","signed_by","comments","signed_on","updated_at","conf_id"]
	try:
		APIKEY         = request.values.get("api_key") or None
		conf_id	       = request.values.get('conf_id') or None
		del_table_name = request.values.get('del_table_name') or None
		date_1         = request.values.get('date_1') or None
		if APIKEY  and  APIKEY == Custom.APIKEY :
			delegate_data_and_count = RegdeskModel().syncAllDataWithSignedCount(conf_id,del_table_name,date_1)
			if delegate_data_and_count :
				for index,value in enumerate(delegate_data_and_count) :
					if index == 0 :
						delegate_data  = value
						# print(delegate_data)
					if index == 1 :
						signed_count_1 = value	

				if signed_count_1 :
					signed_count = signed_count_1[0]["signed_count"]
					
				data = {"delegate_data" : delegate_data,"signed_count" : signed_count, "msg" : "success" , "status" : 1}

				result = defaultdict(list)
				for dic in data["delegate_data"]:
					ordered = OrderedDict((key, dic.get(key)) for key in key_order)
					result["delegate_data"].append(ordered)

				json_data = dumps(data ,default=str)
				return json_data
			else :
				msg    = "Signed data does not exist"
				status = 3
				data   = { "delegate_data" : "","signed_count" : signed_count,  "msg" : msg , "status" : status}
				
			# json_data = json.dumps(data ,default=str)
			json_data = jsonify(data)
			return json_data	
		else :
			data = {'delegate_data' : '','signed_count' : 0 ,'msg' : 'Invalid API KEY', 'status' : 2}
			json_data = json.dumps(data ,default=str)
			return json_data	
	except Exception as e:
		data = {'signed_count' : 0,'signed_count' : 0 , 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data ,default=str)
		return json_data



# save  singed data and get only another device singed data to sent android 
# it reduce the loading time
# http://127.0.0.1:5001/save_singup_record?api_key=w347H52d96&del_table_name=delegates_selsi22&device_id=android123
# @app.route('/save_singup_record', methods = ["GET", "POST"])
# def SaveSignupRecord():
# 	json_data    = {}
# 	delegate_nos = []
# 	update_stmt  = "" 
# 	now          = datetime.now()
# 	curr_dt      = now.strftime("%Y-%m-%d %H:%M:%S")
# 	try:
# 		APIKEY         = request.values.get("api_key") or None
# 		del_table_name = request.values.get('del_table_name') or None
# 		delegate_no    = request.values.get('delegate_no') or None	
# 		signed_by	   = request.values.get('signed_by') or None	
# 		comments	   = request.values.get('comments') or None
# 		if APIKEY  and  APIKEY == Custom.APIKEY :
# 			sync_data = request.json
# 			if sync_data :
# 				for index,value in enumerate(sync_data) :
# 					delegate_no = value["delegate_no"]
# 					signed_on   = value["signed_on"]
# 					comments    = value["comments"]
# 					signed_by   = value["signed_by"]
# 					device_id   = value["device_id"]
# 					delegate_nos.append(delegate_no)
# 					update_stmt = update_stmt + " update  " + del_table_name + " set signed_on = '"+signed_on+"' , comments = '" + comments+"' , signed_by ='" + signed_by+"',sync_at= '"+curr_dt+"' , device_id = '"+device_id+"' where delegate_no = "+str(delegate_no)+ "; \n"

# 				delegate_no_str = str(delegate_nos)
# 				delegate_no_str = delegate_no_str.replace("[" , "").replace("]" , "")
				
# 				update_and_singed_data = RegdeskModel().updatRegdeskSignedData(del_table_name,update_stmt,delegate_no_str,device_id)
# 				print(update_stmt)
# 				if update_and_singed_data :
# 					data = {'delegate_data' : update_and_singed_data , 'msg' : 'success' ,'status' : 1}
# 				else : 
# 					data = {'delegate_data' : [] , 'msg' : 'No signed records to update' ,'status' : 2}

# 				json_data = json.dumps(data ,default=str)
# 				return json_data
# 			else :
# 				print("sync_data not exist")
# 				data = {'delegate_data' : [] , 'msg' : 'Signed in data not exist from API' ,'status' : 3}
# 				json_data = json.dumps(data ,default=str)
# 				return json_data	
# 		else :
# 			data = {'delegate_data' : [] , 'msg' : 'Invalid API KEY', 'status' : 5}
# 			json_data = json.dumps(data ,default=str)
# 			return json_data	
# 	except Exception as e:
# 		data = {'delegate_data' : [] , 'msg' : str(e), 'status' : 401}
# 		json_data = json.dumps(data ,default=str)
# 		return json_data

# http://127.0.0.1:5001/get_singup_record?api_key=w347H52d96&del_table_name=delegates_selsi22&device_id=android123
@app.route('/get_singup_record', methods = ["GET", "POST"])
def GetSignupRecord():
	json_data    = {}
	delegate_nos = []
	try:
		APIKEY         = request.values.get("api_key") or None
		del_table_name = request.values.get('del_table_name') or None
		device_id      = request.values.get('device_id') or None		
		if APIKEY  and  APIKEY == Custom.APIKEY :
			delegate_nos = request.json
			if delegate_nos :
				delegate_no_str = str(delegate_nos)
				delegate_no_str = delegate_no_str.replace("[" , "").replace("]" , "")
			else : 
				delegate_no_str  = None	
				
			get_singed_data = RegdeskModel().getRegdeskSignedData(del_table_name,delegate_no_str,device_id)
			if get_singed_data :
				data = {'delegate_data' : get_singed_data , 'msg' : 'success' ,'status' : 1}
			else : 
				data = {'delegate_data' : [] , 'msg' : 'No signed records to update' ,'status' : 2}	
				
		else :
			data = {'delegate_data' : [] , 'msg' : 'Invalid API KEY', 'status' : 5}

		json_data = json.dumps(data,default =str)
		return json_data
	except Exception as e:
		data = {'delegate_data' : [] , 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data ,default=str)
		return json_data	


	 
	

