## Current session controller
# Priyavarthana
from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
import datetime
from datetime import timedelta,date,datetime
from flask import session, app
from .. import Cryptography,Auth,RouteGroup,Helper
from core.model.BadgeModel import BadgeModel
from core.model.QueryModel import QueryModel
from core.model.CurrentSessionModel import CurrentSessionModel
from core.model.HallLogsModel import HallLogsModel

app = Blueprint('currentsession', __name__)

@app.route('/<int:conf_id>/<conf_key>/current_sessions', methods = ["GET", "POST"])
def getCurrentSession(conf_id,conf_key):
	get_conf  = BadgeModel().GetConf(conf_id,conf_key)
	now       = datetime.now()
	current_date   = now.strftime('%Y-%m-%d ')

# 	current_date = "2023-08-04"
	current_date =str(current_date)
	get_data = CurrentSessionModel().getCurrentActiveSession(get_conf['abs_ses_table_name'],conf_id,conf_key,current_date)
	return render_template('current_session/user/index.html',getDays=get_data,conf_data=get_conf,conf_id=conf_id,conf_key=conf_key)
	


@app.route('/<int:conf_id>/<conf_key>/get_active_current_sessions', methods = ["GET", "POST"])
def getActiveCurrentSessions(conf_id,conf_key):
	conf_data  = BadgeModel().GetConf(conf_id,conf_key)
	now              = datetime.now()
	current_date   	 = now.strftime('%Y-%m-%d ')
# 	current_date = "2023-08-04"

	current_date =str(current_date)
	get_data = CurrentSessionModel().getCurrentActiveSession(conf_data['abs_ses_table_name'],conf_id,conf_key,current_date)

	html = render_template('current_session/user/index_table.html',conf_id=conf_id,conf_key=conf_key,getDays=get_data)

	return jsonify({'html':html})






@app.route('/<int:conf_id>/<conf_key>/active_sessions', methods = ["GET", "POST"])
def getHalls(conf_id,conf_key):
	get_conf  = BadgeModel().GetConf(conf_id,conf_key)
	now       = datetime.now()
	current_date   = now.strftime('%Y-%m-%d')
# 	current_date = "2023-08-04"

	current_date =str(current_date)
	getHalls   = QueryModel().getHallsQueryModel(get_conf['abs_ses_table_name'],conf_id,current_date)
	return render_template('current_session/user/halls.html',conf_id=conf_id,conf_key=conf_key,conf_data=get_conf,getHalls=getHalls)


@app.route('/<int:conf_id>/<conf_key>/get_abs_sessions/<hall_id>', methods = ["GET", "POST"])
def getAbsSessions(conf_id,conf_key,hall_id):
	conf_data         = BadgeModel().GetConf(conf_id,conf_key)
	now       = datetime.now()
	current_date   = now.strftime('%Y-%m-%d')
# 	current_date = "2023-08-04"

	current_date =str(current_date)
	getSessionName    = CurrentSessionModel().getSessionName_activated(conf_data['abs_ses_table_name'],conf_id,hall_id,current_date)
	return render_template('current_session/user/session.html',conf_id=conf_id,conf_key=conf_key,conf_data=conf_data,getSessionName=getSessionName)

# @app.route('/<int:conf_id>/<conf_key>/save_active_session', methods = ["GET", "POST"])
# def saveActiveSession(conf_id,conf_key):
# 	conf_data         = BadgeModel().GetConf(conf_id,conf_key)
# 	is_active   = request.values.get('is_active')
# 	asession_id = request.values.get('asession_id')
# 	hall_id     = request.values.get('hall_id')
# 	now         = datetime.now()
# 	current_date   = now.strftime('%Y-%m-%d')
# # 	current_date = "2023-08-04"
# 	current_date =str(current_date)
# 	CurrentSessionModel().updateActiveSession(conf_data['abs_ses_table_name'],conf_id,current_date,hall_id,asession_id,is_active)
# 	HallLogsModel().usp_generate_scan_logs_as_closed(conf_id,hall_id)
# 	HallLogsModel().usp_generate_scan_logs_as_active(conf_id,hall_id)
# 	if int(is_active)  == 1:
# 		data = { "msg" : " Activated Successfully" ,"status" :1}
# 	else:
# 		data = {"msg" : " Unactivated Successfully","status":1}
# 	json_data = json.dumps(data,default=str)
# 	return json_data


@app.route('/<int:conf_id>/<conf_key>/save_active_session', methods = ["GET", "POST"])
def saveActiveSession(conf_id,conf_key):
	conf_data         = BadgeModel().GetConf(conf_id,conf_key)
	is_active   = request.values.get('is_active')
	asession_id = request.values.get('asession_id')
	hall_id     = request.values.get('hall_id')
	now         = datetime.now()
	current_date   = now.strftime('%Y-%m-%d')
# 	current_date = "2023-08-04"
	current_date =str(current_date)
	CurrentSessionModel().updateActiveSession(conf_data['abs_ses_table_name'],conf_id,current_date,hall_id,asession_id,is_active)
	# HallLogsModel().usp_generate_scan_logs_as_closed(conf_id,hall_id)
	
	if int(is_active)  == 1:
		HallLogsModel().usp_generate_scan_logs_as_active(conf_id,hall_id)
		data = { "msg" : " Activated Successfully" ,"status" :1}
	else:
		HallLogsModel().usp_generate_scan_logs_as_closed(conf_id,hall_id)
		data = {"msg" : " Deactivate Successfully","status":1}
	json_data = json.dumps(data,default=str)
	return json_data



@app.route('/<int:conf_id>/<conf_key>/set_no_active_session', methods = ["GET", "POST"])
def SetNoActiveSession(conf_id,conf_key):
	conf_data    = BadgeModel().GetConf(conf_id,conf_key)
	is_active   = request.values.get('is_active')
	abs_hall_id = request.values.get('abs_hall_id')
	current_date = request.values.get('current_date')
	now         = datetime.now()
# 	print(current_date)
	CurrentSessionModel().updateNoActiveSession(conf_data['abs_ses_table_name'],conf_id,current_date,abs_hall_id,is_active)
	HallLogsModel().usp_generate_scan_logs_as_closed(conf_id,abs_hall_id)
	data = {"msg" : "Deactivated the active session successfully","status":1}
	json_data = json.dumps(data,default=str)
	return json_data
